<?php 
namespace MxiDev\renewal;


class AdminArea
{
    public static function create($vars)
    {
        try
        {
            $promoid = (int) Tools::safetyInput($_REQUEST["promoid"]);
            if( empty($promoid) ) 
            {
                throw new \Exception("未传入优惠码ID");
            }

            $multi = (double) Tools::safetyInput($_REQUEST["multi"]);
            if( empty($multi) ) 
            {
                $multi = "0.00";
            }

            $multi = number_format($multi, 2);
            Tools::safetyCheck($_REQUEST["sign"], array( $promoid ));
            $promotions = \WHMCS\Database\Capsule::table("tblpromotions")->where("id", $promoid)->first();
            if( empty($promotions) ) 
            {
                throw new \Exception("无法查询到优惠码，请确认优惠码是否存在");
            }

            $notes = $promotions->notes;
            $notesDetial = explode("|", $notes);
            if( trim($notesDetial[0]) == "renewal" ) 
            {
                $newNotes = implode("|", array( "renewal", $multi, $notesDetial[2] ));
                $updatePromo = \WHMCS\Database\Capsule::table("tblpromotions")->where("id", $promoid)->update(array( "notes" => $newNotes ));
                Tools::outputJSON(array( "status" => "success" ));
            }
            else
            {
                $newNotes = implode("|", array( "renewal", $multi, $notes ));
                $updatePromo = \WHMCS\Database\Capsule::table("tblpromotions")->where("id", $promoid)->update(array( "notes" => $newNotes ));
                if( $updatePromo ) 
                {
                    Tools::outputJSON(array( "status" => "success" ));
                }
                else
                {
                    throw new \Exception("无法修改优惠码信息");
                }

            }

        }
        catch( \Exception $e ) 
        {
            Tools::outputJSON(array( "status" => "error", "msg" => $e->getMessage() ));
        }
    }

    public static function delete($vars)
    {
        try
        {
            $promoid = (int) Tools::safetyInput($_REQUEST["promoid"]);
            if( empty($promoid) ) 
            {
                throw new \Exception("未传入优惠码ID");
            }

            Tools::safetyCheck($_REQUEST["sign"], array( $promoid ));
            $promotions = \WHMCS\Database\Capsule::table("tblpromotions")->where("id", $promoid)->first();
            $notes = explode("|", $promotions->notes);
            if( trim($notes[0]) == "renewal" ) 
            {
                $updatePromo = \WHMCS\Database\Capsule::table("tblpromotions")->where("id", $promoid)->update(array( "notes" => $notes[2] ));
                if( $updatePromo ) 
                {
                    Tools::outputJSON(array( "status" => "success" ));
                }
                else
                {
                    throw new \Exception("无法修改优惠码信息");
                }

            }
            else
            {
                throw new \Exception("当前优惠码不允许在续费时使用");
            }

        }
        catch( \Exception $e ) 
        {
            Tools::outputJSON(array( "status" => "error", "msg" => $e->getMessage() ));
        }
    }

    public static function checkUpdate()
    {
        try
        {
            $License = License::doCheck();
            if( $_POST ) 
            {
                try
                {
                    $responseCode = "0";
                    $client = new GuzzleHttp\Client(array( "base_uri" => "https://mxidev-version.mdzz.gs/version/", "timeout" => 15 ));
                    $response = $client->request("POST", "version.php", array( "form_params" => array( "sid" => $License["serviceid"], "pid" => $License["productid"], "email" => $License["email"], "info" => json_encode(Tools::getServerInfo()) ), "connect_timeout" => 15, "http_errors" => false ));
                    $responseCode = $response->getStatusCode();
                    $data = (string) $response->getBody();
                }
                catch( \Exception $e ) 
                {
                    if( $e->getMessage() ) 
                    {
                        $description = ": " . $e->getMessage();
                    }
                    else
                    {
                        $description = ".";
                    }

                    throw new \Exception("无法连接到版本查询服务器" . $description);
                }
                if( $responseCode != "200" ) 
                {
                    throw new \Exception("错误的响应代码 :" . $responseCode);
                }

                $data = json_decode($data, true);
                if( empty($data) || !is_array($data) ) 
                {
                    throw new \Exception("无法获取到响应内容");
                }

                Tools::outputJSON($data);
            }
            else
            {
                throw new \Exception("非法请求");
            }

        }
        catch( \Exception $e ) 
        {
            Tools::outputJSON(array( "status" => "error", "msg" => $e->getMessage() ));
        }
    }

    public static function getData($vars)
    {
        try
        {
            $billingcycleLangList = array( "Free Account" => \LANG::trans("orderpaymenttermfreeaccount"), "One Time" => \LANG::trans("orderpaymenttermonetime"), "Monthly" => \LANG::trans("orderpaymenttermmonthly"), "Quarterly" => \LANG::trans("orderpaymenttermquarterly"), "Semi-Annually" => \LANG::trans("orderpaymenttermsemiannually"), "Annually" => \LANG::trans("orderpaymenttermannually"), "Biennially" => \LANG::trans("orderpaymenttermbiennially"), "Triennially" => \LANG::trans("orderpaymenttermtriennially") );
            $invoiceStatusLangList = array( "Paid" => \LANG::trans("invoicespaid"), "Unpaid" => \LANG::trans("invoicesunpaid"), "Cancelled" => \LANG::trans("invoicescancelled"), "Collections" => \LANG::trans("invoicescollections"), "Refunded" => \LANG::trans("invoicesrefunded") );
            $product = DB::orderBy("id", "DESC")->get();
            $renewLog = array(  );
            foreach( $product as $key => $value ) 
            {
                $sid = $value->sid;
                $productDetial = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->first();
                $productname = \WHMCS\Database\Capsule::table("tblproducts")->where("id", $productDetial->packageid)->select("name")->first()->name;
                $uid = $productDetial->userid;
                $userDetial = \WHMCS\Database\Capsule::table("tblclients")->where("id", $uid)->select("firstname", "lastname")->first();
                $invoiceStatus = \WHMCS\Database\Capsule::table("tblinvoices")->where("id", $value->invoiceid)->select("status")->first()->status;
                $invoiceStatus = (empty($invoiceStatusLangList[$invoiceStatus]) ? $invoiceStatus : $invoiceStatusLangList[$invoiceStatus]);
                array_push($renewLog, array( "id" => $value->id, "userDetial" => "<a href=\"clientssummary.php?userid=" . $uid . "\" target=\"_blank\">" . $userDetial->lastname . " " . $userDetial->firstname . " (UID: " . $uid . ")</a>", "sid" => "<a href=\"clientsservices.php?productselect=" . $sid . "\" target=\"_blank\">" . $sid . "</a>", "product" => "<a href=\"clientsservices.php?productselect=" . $sid . "\" target=\"_blank\">" . $productname . "</a>(" . $productDetial->domain . ")", "old_amount" => $value->old_amount, "new_amount" => $value->new_amount, "old_billingcycle" => (empty($billingcycleLangList[$value->old_billingcycle]) ? $value->old_billingcycle : $billingcycleLangList[$value->old_billingcycle]), "new_billingcycle" => (empty($billingcycleLangList[$value->new_billingcycle]) ? $value->new_billingcycle : $billingcycleLangList[$value->new_billingcycle]), "old_nextduedate" => $value->old_nextduedate, "new_nextduedate" => $value->new_nextduedate, "times" => $value->times, "promocode" => $value->promocode, "invoiceid" => "<a href=\"invoices.php?action=edit&id=" . $value->invoiceid . "\" target=\"_blank\">" . $value->invoiceid . "</a>", "status" => $invoiceStatus, "credit" => $value->credit, "updated_at" => $value->updated_at->toDateTimeString() ));
            }
            Tools::outputJSON(array( "status" => "success", "msg" => $renewLog ));
        }
        catch( \Exception $e ) 
        {
            Tools::outputJSON(array( "status" => "error", "msg" => $e->getMessage() ));
        }
    }

    public static function delData($vars)
    {
        try
        {
            $select = (string) Tools::safetyInput($_REQUEST["select"]);
            if( empty($select) ) 
            {
                throw new \Exception("您还未选择需要删除的记录");
            }

            $selects = explode("|", $select);
            $selects = array_filter($selects);
            $i = 0;
            foreach( $selects as $key => $value ) 
            {
                DB::where("id", $value)->delete();
                $i++;
            }
            Tools::outputJSON(array( "status" => "success", "rows" => $i ));
        }
        catch( \Exception $e ) 
        {
            Tools::outputJSON(array( "status" => "error", "msg" => $e->getMessage() ));
        }
    }

    public static function output($vars)
    {
        try
        {
            $License = Tools::getRoute(License::doCheck());
            $promotions = \WHMCS\Database\Capsule::table("tblpromotions")->where("type", "Fixed Amount")->orWhere("type", "Percentage")->orderBy("id", "ASC")->get();
            foreach( $promotions as $key => $value ) 
            {
                $value = json_decode(json_encode($value), true);
                if( !($value["expirationdate"] != "0000-00-00" && strtotime($value["expirationdate"]) < time() - "86400") && !($value["maxuses"] - $value["uses"] <= 0 && $value["maxuses"] != "0") ) 
                {
                    $sign = Tools::safetyCheck("", array( $value["id"] ), true);
                    if( $value["type"] == "Fixed Amount" ) 
                    {
                        $value["type"] = "固定金额";
                    }

                    if( $value["type"] == "Percentage" ) 
                    {
                        $value["type"] = "百分比";
                    }

                    $notes = trim($value["notes"]);
                    $notes = explode("|", $notes);
                    if( trim($notes[0]) == "renewal" ) 
                    {
                        $value["multi"] = $notes[1];
                        $value["sign"] = $sign;
                        $renewalPromo[$key] = $value;
                    }
                    else
                    {
                        $value["sign"] = $sign;
                        $unReNewPromo[$key] = $value;
                    }

                }

            }
            $smarty = Tools::getSmarty(array( "dir" => realpath(__DIR__ . "/../templates"), "file" => "/manage", "vars" => array( "modulevars" => $vars, "License" => $License, "templates" => array( "renewalPromo" => $renewalPromo, "unReNewPromo" => $unReNewPromo ) ) ));
        }
        catch( \Exception $e ) 
        {
            $smarty = Tools::getSmarty(array( "dir" => realpath(__DIR__ . "/../templates"), "file" => "/error", "vars" => array( "page" => "adminarea", "info" => $e->getMessage() ) ));
        }
        echo $smarty;
    }

}
?>