<?php 
namespace MxiDev\renewal;

if( !class_exists("Apps") ) 
{

class Apps
{
    public static $vars = array(  );
    public static $modulename = "renewal";
    public static $name = "Renewal Manager";
    public static $description = "此插件可允许用户提前续费服务，并允许使用优惠码";
    public static $version = "2.5";
    public static $author = "<a href=\"https://mxidev.com\" target=\"_blank\">MxiDev</a>";

    public function __construct($vars = array(  ))
    {
        self::$vars = $vars;
    }

    public static function config()
    {
        try
        {
            License::doCheck();
            $configarray = array( "name" => self::$name, "description" => self::$description, "version" => self::$version, "author" => self::$author, "fields" => array( "licensekey" => array( "FriendlyName" => "许可密钥", "Type" => "text", "Size" => "40", "Description" => "请在此输入许可密钥" ), "allowChangeBillingCycle" => array( "FriendlyName" => "不允许用户更改付款周期", "Type" => "yesno", "Size" => "25", "Description" => "勾选后，用户不可以在续费时选择付款周期，只能按照当前的付款周期续费。例如选中后月付不可续费为年付" ), "allowCancleInvoices" => array( "FriendlyName" => "在续费时取消未支付账单", "Type" => "yesno", "Size" => "25", "Default" => "yes", "Description" => "勾选后，用户在续费时如果有与当前产品相关的账单且未支付，将自动将其标记为被取消，不影响续费的进行" ), "multiRenewWithPromo" => array( "FriendlyName" => "使用优惠码时禁止多次续费", "Type" => "yesno", "Size" => "25", "Default" => "yes", "Description" => "勾选后，使用 Renewal 续费时使用优惠码的同时不允许多次进行续费，避免优惠码被多次使用" ), "updateAmount" => array( "FriendlyName" => "续约价格覆盖", "Type" => "yesno", "Size" => "25", "Description" => "勾选后，使用 Renewal 续费会将续约价格覆盖为当前续约价格，应用优惠码后同样适用，多次续费时会计算单次续费的价格" ), "tryRenewAfterError" => array( "FriendlyName" => "出现错误后尝试解决", "Type" => "yesno", "Size" => "25", "Default" => "yes", "Description" => "勾选后，使用 Renewal 续费时出现“创建续费订单失败，可能是您的服务不支持续费”，将尝试解决，若出现空账单现象，关闭即可解决问题" ), "sign" => array( "FriendlyName" => "安全效验码", "Type" => "text", "Size" => "20", "Default" => Tools::getRand(10), "Description" => "自动生成10位随机码" ) ) );
        }
        catch( \Exception $e ) 
        {
            $configarray = array( "name" => self::$name, "description" => self::$description, "version" => self::$version, "author" => self::$author, "fields" => array( "licensekey" => array( "FriendlyName" => "许可密钥", "Type" => "text", "Size" => "25", "Description" => "请在此输入许可密钥" ), "sign" => array( "FriendlyName" => "安全效验码", "Type" => "text", "Size" => "20", "Default" => Tools::getRand(10), "Description" => "自动生成10位随机码" ), "error" => array( "FriendlyName" => "出现错误！", "Type" => "yesno", "Size" => "25", "Description" => "<strong>错误信息：</strong>" . $e->getMessage() ) ) );
        }
        return $configarray;
    }

    public static function activate()
    {
        try
        {
            Schema::dropIfExists("mod_renewal_log");
            Schema::create("mod_renewal_log", function(\Illuminate\Database\Schema\Blueprint $table)
{
    $table->increments("id");
    $table->integer("sid");
    $table->decimal("old_amount", 10, 2)->nullable();
    $table->decimal("new_amount", 10, 2)->nullable();
    $table->integer("invoiceid")->nullable();
    $table->string("old_billingcycle")->nullable();
    $table->string("new_billingcycle")->nullable();
    $table->string("old_nextduedate")->nullable();
    $table->string("new_nextduedate")->nullable();
    $table->integer("times")->nullable();
    $table->string("promocode")->nullable();
    $table->decimal("credit", 10, 2)->default("0.00");
    $table->timestamps();
}

);
            return array( "status" => "success", "description" => "模块激活成功，请点击配置进行设置" );
        }
        catch( \Exception $e ) 
        {
            return array( "status" => "error", "description" => "模块激活失败: " . $e->getMessage() );
        }
    }

    public static function deactivate()
    {
        try
        {
            $templates_c = Tools::getTemplatesC();
            Tools::delFile($templates_c . "/renewal_License.php");
            \Illuminate\Database\Capsule\Manager::table("tbladdonmodules")->where("module", "renewal")->delete();
            Schema::dropIfExists("mod_renewal");
            return array( "status" => "success", "description" => "模块卸载成功" );
        }
        catch( \Exception $e ) 
        {
            return array( "status" => "error", "description" => "无法删除数据: " . $e->getMessage() );
        }
    }

    public static function upgrade()
    {
        try
        {
            $vars = self::$vars;
            $version = $vars["version"];
            if( $version < "2.2" ) 
            {
                if( "2.0" <= $version ) 
                {
                    Schema::dropIfExists("mod_renewal");
                }

                Schema::dropIfExists("mod_renewal_log");
                Schema::create("mod_renewal_log", function(\Illuminate\Database\Schema\Blueprint $table)
{
    $table->increments("id");
    $table->integer("sid");
    $table->decimal("old_amount", 10, 2)->nullable();
    $table->decimal("new_amount", 10, 2)->nullable();
    $table->integer("invoiceid")->nullable();
    $table->string("old_billingcycle")->nullable();
    $table->string("new_billingcycle")->nullable();
    $table->string("old_nextduedate")->nullable();
    $table->string("new_nextduedate")->nullable();
    $table->integer("times")->nullable();
    $table->string("promocode")->nullable();
    $table->decimal("credit", 10, 2)->default("0.00");
    $table->timestamps();
}

);
            }

        }
        catch( \Exception $e ) 
        {
            return array( "status" => "error", "description" => "出现错误: " . $e->getMessage() );
        }
    }

    public static function output()
    {
        switch( $_REQUEST["action"] ) 
        {
            case "create":
                return AdminArea::create(self::$vars);
            case "delete":
                return AdminArea::delete(self::$vars);
            case "getData":
                return AdminArea::getData(self::$vars);
            case "delData":
                return AdminArea::delData(self::$vars);
            case "checkUpdate":
                return AdminArea::checkUpdate();
        }
        return AdminArea::output(self::$vars);
    }

    public static function clientarea()
    {
        switch( $_REQUEST["action"] ) 
        {
            case "renew":
                return ClientArea::renew(self::$vars);
            case "getPrice":
                return ClientArea::getPrice(self::$vars);
            case "doReNew":
                return ClientArea::doRenew(self::$vars);
            case "debug":
                return ClientArea::debug(self::$vars);
        }
        return ClientArea::home(self::$vars);
    }

    public static function hooks()
    {
        add_hook("DailyCronJob", 1, function($vars)
{
    try
    {
        License::doCheck(true);
    }
    catch( \Exception $e ) 
    {
    }
}

);
        add_hook("ClientAreaPrimaryNavbar", -1, function($menu)
{
    try
    {
        if( !is_null($menu->getChild("Billing")) ) 
        {
            $RENEWAL_LANG = Tools::getLang();
            $menu->getChild("Billing")->addChild($RENEWAL_LANG["addonsName"], array( "uri" => "index.php?m=renewal", "order" => 11 ));
        }

    }
    catch( \Exception $e ) 
    {
    }
}

);
        add_hook("InvoicePaid", 1, function($vars)
{
    try
    {
        $updateAmount = Tools::getModuleVars("updateAmount");
        if( !$updateAmount == "on" ) 
        {
            $notallowUpdateAmount = true;
        }

        if( !$notallowUpdateAmount ) 
        {
            $invoiceid = $vars["invoiceid"];
            $invoiceDetial = DB::where("invoiceid", $invoiceid)->select("new_amount", "sid", "times")->first();
            if( !empty($invoiceDetial) ) 
            {
                $new_amount = $invoiceDetial->new_amount;
                $sid = $invoiceDetial->sid;
                $times = $invoiceDetial->times;
                if( empty($sid) ) 
                {
                    throw new \Exception("产品ID为空");
                }

                if( empty($new_amount) ) 
                {
                    throw new \Exception("产品ID: " . $sid . " 下次续费金额为空");
                }

                if( empty($times) ) 
                {
                    throw new \Exception("产品ID: " . $sid . " 续费次数为空");
                }

                $new_amount = $new_amount / $times;
                \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->update(array( "amount" => $new_amount ));
            }

        }

    }
    catch( \Exception $e ) 
    {
        logActivity("renewal: 自动更新下次续费金额时出错: " . $e->getMessage());
    }
}

);
    }

}

}

if( !class_exists("License") ) 
{

class License
{
    private static $licensing_secret_key = "pZPYEndPVtAuzSBK";

    public static function doCheck($force = false)
    {
        $licensekey = Tools::getModuleVars("licensekey");
        $localkey = Tools::getFile(Tools::getTemplatesC() . "/renewal_License.php");
        if( $force ) 
        {
            $getLicense = self::getLicense($licensekey);
        }
        else
        {
            $getLicense = self::getLicense($licensekey, $localkey);
        }

        $checkLicense = self::checkLicense($getLicense);
        return $checkLicense;
    }

    public static function getLicense($licensekey, $localkey = "")
    {
        if( empty($licensekey) ) 
        {
            throw new \Exception("您还未输入授权密钥");
        }

        $localkeydays = 15;
        $allowcheckfaildays = 5;
        $check_token = time() . md5(mt_rand(1000000000, 9999999999) . $licensekey);
        $checkdate = date("Ymd");
        $serverInfo = Tools::getServerInfo();
        $domain = $serverInfo["domain"];
        $usersip = $serverInfo["ip"];
        $dirpath = $serverInfo["dir"];
        $localkeyvalid = false;
        if( $localkey ) 
        {
            $localkey = str_replace("\n", "", $localkey);
            $localdata = substr($localkey, 0, strlen($localkey) - 32);
            $md5hash = substr($localkey, strlen($localkey) - 32);
            if( $md5hash == md5($localdata . self::$licensing_secret_key) ) 
            {
                $localdata = strrev($localdata);
                $md5hash = substr($localdata, 0, 32);
                $localdata = substr($localdata, 32);
                $localdata = base64_decode($localdata);
                $localkeyresults = unserialize($localdata);
                $originalcheckdate = $localkeyresults["checkdate"];
                if( $md5hash == md5($originalcheckdate . self::$licensing_secret_key) ) 
                {
                    $localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - $localkeydays, date("Y")));
                    if( $localexpiry < $originalcheckdate ) 
                    {
                        $localkeyvalid = true;
                        $results = $localkeyresults;
                        $validdomains = explode(",", $results["validdomain"]);
                        if( !in_array($_SERVER["SERVER_NAME"], $validdomains) ) 
                        {
                            $localkeyvalid = false;
                            $localkeyresults["status"] = "Invalid";
                            $results = array(  );
                        }

                        $validips = explode(",", $results["validip"]);
                        if( !in_array($usersip, $validips) ) 
                        {
                            $localkeyvalid = false;
                            $localkeyresults["status"] = "Invalid";
                            $results = array(  );
                        }

                        $validdirs = explode(",", $results["validdirectory"]);
                        if( !in_array($dirpath, $validdirs) ) 
                        {
                            $localkeyvalid = false;
                            $localkeyresults["status"] = "Invalid";
                            $results = array(  );
                        }

                    }

                }

            }

        }

        if( !$localkeyvalid ) 
        {
            $responseCode = 0;
            if( $check_token ) 
            {
                $postfields["check_token"] = $check_token;
            }

            try
            {
                $client = new GuzzleHttp\Client(array( "base_uri" => "https://mxidev-api.mdzz.gs/licensing/", "timeout" => 15 ));
                $response = $client->request("POST", "verify.php", array( "form_params" => $serverInfo, "connect_timeout" => 15, "http_errors" => false ));
                $responseCode = $response->getStatusCode();
                $data = (string) $response->getBody();
            }
            catch( \Exception $e ) 
            {
                if( $e->getMessage() ) 
                {
                    $description = ": " . $e->getMessage();
                }
                else
                {
                    $description = ".";
                }

                throw new \Exception("Can not connect to License Server" . $description);
            }
            if( $responseCode != 200 ) 
            {
                $localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - ($localkeydays + $allowcheckfaildays), date("Y")));
                if( $localexpiry < $originalcheckdate ) 
                {
                    $results = $localkeyresults;
                }
                else
                {
                    $results = array(  );
                    $results["status"] = "Invalid";
                    $results["description"] = "Remote Check Failed, response code: " . $responseCode;
                    return $results;
                }

            }
            else
            {
                $results = json_decode($data, true);
            }

            if( !is_array($results) ) 
            {
                throw new \Exception("Invalid License Server Response");
            }

            if( $results["md5hash"] && $results["md5hash"] != md5(self::$licensing_secret_key . $check_token) ) 
            {
                $results["status"] = "Invalid";
                $results["description"] = "MD5 Checksum Verification Failed";
                return $results;
            }

            if( $results["status"] == "Active" ) 
            {
                $results["checkdate"] = $checkdate;
                $data_encoded = serialize($results);
                $data_encoded = base64_encode($data_encoded);
                $data_encoded = md5($checkdate . self::$licensing_secret_key) . $data_encoded;
                $data_encoded = strrev($data_encoded);
                $data_encoded = $data_encoded . md5($data_encoded . self::$licensing_secret_key);
                $data_encoded = wordwrap($data_encoded, 80, "\n", true);
                $results["localkey"] = $data_encoded;
            }

            $results["remotecheck"] = true;
        }

        unset($data);
        unset($checkdate);
        unset($usersip);
        unset($dirpath);
        unset($domain);
        unset($localkeydays);
        unset($allowcheckfaildays);
        unset($md5hash);
        unset($client);
        unset($response);
        return $results;
    }

    public static function checkLicense($results = "")
    {
        $templates_c = Tools::getTemplatesC();
        switch( $results["status"] ) 
        {
            case "Active":
                if( !empty($results["localkey"]) ) 
                {
                    Tools::putFile($templates_c . "/renewal_License.php", $results["localkey"]);
                }

                break;
            case "Invalid":
                Tools::delFile($templates_c . "/renewal_License.php");
                if( !empty($results["description"]) ) 
                {
                    $description = ": " . $results["description"];
                }
                else
                {
                    $description = ".";
                }

                throw new \Exception("License key is Invalid" . $description);
            case "Expired":
                Tools::delFile($templates_c . "/renewal_License.php");
                if( !empty($results["description"]) ) 
                {
                    $description = ": " . $results["description"];
                }
                else
                {
                    $description = ".";
                }

                throw new \Exception("License key is Expired" . $description);
            case "Suspended":
                Tools::delFile($templates_c . "/renewal_License.php");
                if( !empty($results["description"]) ) 
                {
                    $description = ": " . $results["description"];
                }
                else
                {
                    $description = ".";
                }

                throw new \Exception("License key is Suspended" . $description);
            default:
                throw new \Exception("Invalid Response");
        }
        return $results;
    }

}

}
?>