<?php 
namespace MxiDev\renewal;


class ClientArea
{
    public static function home($vars)
    {
        try
        {
            Tools::getRoute(License::doCheck());
            $RENEWAL_LANG = Tools::getLang();
            $uid = (int) $_SESSION["uid"];
            if( empty($uid) ) 
            {
                throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetUid"]);
            }

            $products = \WHMCS\Database\Capsule::table("tblhosting")->where("userid", $uid)->get();
            $product = array(  );
            $billingcycleLangList = array( "Free Account" => \LANG::trans("orderpaymenttermfreeaccount"), "One Time" => \LANG::trans("orderpaymenttermonetime"), "Monthly" => \LANG::trans("orderpaymenttermmonthly"), "Quarterly" => \LANG::trans("orderpaymenttermquarterly"), "Semi-Annually" => \LANG::trans("orderpaymenttermsemiannually"), "Annually" => \LANG::trans("orderpaymenttermannually"), "Biennially" => \LANG::trans("orderpaymenttermbiennially"), "Triennially" => \LANG::trans("orderpaymenttermtriennially") );
            foreach( $products as $key => $value ) 
            {
                $productname = \WHMCS\Database\Capsule::table("tblproducts")->where("id", $value->packageid)->first()->name;
                if( $value->domainstatus == "Active" ) 
                {
                    if( $value->billingcycle == "Free Account" || $value->billingcycle == "One Time" ) 
                    {
                    }
                    else
                    {
                        $timeLeft = floor((strtotime($value->nextduedate) - time()) / 86400);
                        array_push($product, array( "sid" => $value->id, "productname" => $productname, "domain" => $value->domain, "nextduedate" => $value->nextduedate, "amount" => $value->amount, "timeLeft" => $timeLeft, "billingcycle" => $billingcycleLangList[$value->billingcycle] ));
                    }

                }

            }
            return array( "pagetitle" => $RENEWAL_LANG["addonsName"], "breadcrumb" => array( "index.php?m=renewal" => $RENEWAL_LANG["addonsName"] ), "templatefile" => "library/templates/home", "requirelogin" => true, "vars" => array( "templates" => array( "product" => $product ), "RENEWAL_LANG" => $RENEWAL_LANG ) );
        }
        catch( \Exception $e ) 
        {
            try
            {
                $RENEWAL_LANG = Tools::getLang();
                return array( "pagetitle" => $RENEWAL_LANG["addonsName"], "breadcrumb" => array( "index.php?m=renewal" => $RENEWAL_LANG["addonsName"] ), "templatefile" => "library/templates/error", "requirelogin" => true, "vars" => array( "page" => "clientarea", "RENEWAL_LANG" => $RENEWAL_LANG, "info" => $e->getMessage() ) );
            }
            catch( \Exception $e ) 
            {
                return array( "pagetitle" => "续费管理", "breadcrumb" => array( "index.php?m=renewal" => "续费管理" ), "templatefile" => "library/templates/error", "requirelogin" => true, "vars" => array( "page" => "clientarea", "info" => $e->getMessage() ) );
            }
        }
    }

    public static function renew($vars)
    {
        try
        {
            Tools::getRoute(License::doCheck());
            $RENEWAL_LANG = Tools::getLang();
            if( !$vars["allowChangeBillingCycle"] == "on" ) 
            {
                $allowChangeBillingCycle = true;
            }

            if( !empty($vars["allowCancleInvoices"]) ) 
            {
                $allowCancleInvoices = true;
            }

            $uid = (int) $_SESSION["uid"];
            if( empty($uid) ) 
            {
                throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetUid"], 400);
            }

            $sid = (int) Tools::safetyInput($_REQUEST["sid"]);
            if( empty($sid) ) 
            {
                throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetSid"], 400);
            }

            $product = \WHMCS\Database\Capsule::table("tblhosting")->where("userid", $uid)->where("id", $sid)->where("domainstatus", "Active")->first();
            if( empty($product) ) 
            {
                throw new \Exception($RENEWAL_LANG["errorTips"]["canNotFindProduct"], 400);
            }

            $products = \WHMCS\Database\Capsule::table("tblproducts")->where("id", $product->packageid)->first();
            if( !$allowCancleInvoices ) 
            {
                $getProductInvioce = \WHMCS\Database\Capsule::table("tblinvoiceitems")->where("relid", $sid)->where("type", "Hosting")->orderBy("id", "DESC")->first();
                if( !empty($getProductInvioce) ) 
                {
                    $invoiceID = $getProductInvioce->invoiceid;
                    $getInvoicesDetial = \WHMCS\Database\Capsule::table("tblinvoices")->where("id", $invoiceID)->get();
                    foreach( $getInvoicesDetial as $key => $value ) 
                    {
                        if( $value->status == "Unpaid" ) 
                        {
                            throw new \Exception($RENEWAL_LANG["errorTips"]["invoiceUnpaid"], 400);
                        }

                    }
                }

            }

            $billingcycleLangList = array( "Free Account" => \LANG::trans("orderpaymenttermfreeaccount"), "One Time" => \LANG::trans("orderpaymenttermonetime"), "Monthly" => \LANG::trans("orderpaymenttermmonthly"), "Quarterly" => \LANG::trans("orderpaymenttermquarterly"), "Semi-Annually" => \LANG::trans("orderpaymenttermsemiannually"), "Annually" => \LANG::trans("orderpaymenttermannually"), "Biennially" => \LANG::trans("orderpaymenttermbiennially"), "Triennially" => \LANG::trans("orderpaymenttermtriennially") );
            $templates["billingcycle"] = $billingcycleLangList[$product->billingcycle];
            if( empty($templates["billingcycle"]) ) 
            {
                $templates["billingcycle"] = $product->billingcycle;
            }

            unset($billingcycleLangList["Free Account"]);
            unset($billingcycleLangList["One Time"]);
            $billingcycleList = array( 1 => "Monthly", 3 => "Quarterly", 6 => "Semi-Annually", 12 => "Annually", 24 => "Biennially", 36 => "Triennially" );
            if( !$allowChangeBillingCycle ) 
            {
                $billingcycleLang = array(  );
                $billingcycleLang[$product->billingcycle] = $billingcycleLangList[$product->billingcycle];
                unset($billingcycleLangList);
                $billingcycleLangList = $billingcycleLang;
            }

            foreach( $billingcycleLangList as $key => $value ) 
            {
                $tempPrice = Renew::getPrice($uid, $sid, $key);
                if( $key == $product->billingcycle ) 
                {
                    $month = array_search($key, $billingcycleList);
                    $templates["renewalTime"][$month] = $value;
                }
                else
                {
                    if( !($tempPrice["price"] == "0.00" || $tempPrice["price"] == 0) ) 
                    {
                        $month = array_search($key, $billingcycleList);
                        $templates["renewalTime"][$month] = $value;
                    }

                }

            }
            $oldPrice = Renew::getPrice($uid, $sid, $product->billingcycle, true);
            if( $oldPrice["price"] != $product->amount ) 
            {
                $templates["info"] = $RENEWAL_LANG["PriceChangeTips"];
            }

            $templates["name"] = $products->name;
            $templates["sid"] = $product->id;
            $templates["uid"] = $uid;
            $templates["amount"] = $product->amount;
            $templates["paytype"] = $products->paytype;
            $templates["nextduedate"] = $product->nextduedate;
            $templates["month"] = array_search($product->billingcycle, $billingcycleList);
            $templates["sign"] = Tools::safetyCheck("", array( $uid, $sid ), true);
            return array( "pagetitle" => $RENEWAL_LANG["addonsName"], "breadcrumb" => array( "index.php?m=renewal" => $RENEWAL_LANG["addonsName"] ), "templatefile" => "library/templates/renewal", "requirelogin" => true, "vars" => array( "templates" => $templates, "RENEWAL_LANG" => $RENEWAL_LANG ) );
        }
        catch( \Exception $e ) 
        {
            try
            {
                $RENEWAL_LANG = Tools::getLang();
                return array( "pagetitle" => $RENEWAL_LANG["addonsName"], "breadcrumb" => array( "index.php?m=renewal" => $RENEWAL_LANG["addonsName"] ), "templatefile" => "library/templates/error", "requirelogin" => true, "vars" => array( "page" => "clientarea", "RENEWAL_LANG" => $RENEWAL_LANG, "info" => $e->getMessage() ) );
            }
            catch( \Exception $e ) 
            {
                return array( "pagetitle" => "续费管理", "breadcrumb" => array( "index.php?m=renewal" => "续费管理" ), "templatefile" => "library/templates/error", "requirelogin" => true, "vars" => array( "page" => "clientarea", "info" => $e->getMessage() ) );
            }
        }
    }

    public static function debug($vars)
    {
        try
        {
            Tools::outputJSON(array( "modulename" => Apps::$modulename, "version" => Apps::$version, "status" => License::doCheck()["status"] ));
        }
        catch( \Exception $e ) 
        {
            Tools::outputJSON(array( "status" => "error", "msg" => $e->getMessage() ));
        }
    }

    public static function getPrice($vars)
    {
        try
        {
            $RENEWAL_LANG = Tools::getLang();
            $uid = (int) $_SESSION["uid"];
            if( empty($uid) ) 
            {
                throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetUid"], 400);
            }

            $sid = (int) Tools::safetyInput($_REQUEST["sid"]);
            if( empty($sid) ) 
            {
                throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetSid"], 400);
            }

            Tools::safetyCheck((string) $_REQUEST["sign"], array( $uid, $sid ));
            $month = (int) Tools::safetyInput($_REQUEST["month"]);
            $promotion = (string) Tools::safetyInput($_REQUEST["promotion"]);
            $times = (int) $_REQUEST["times"];
            $billingcycleList = array( 1 => "Monthly", 3 => "Quarterly", 6 => "Semi-Annually", 12 => "Annually", 24 => "Biennially", 36 => "Triennially" );
            $billingcycle = $billingcycleList[$month];
            if( empty($billingcycle) ) 
            {
                $billingcycle = "Monthly";
            }

            if( $times <= "0" ) 
            {
                $times = "1";
            }

            if( "36" < $times ) 
            {
                $times = "36";
            }

            $month = array_search($billingcycle, $billingcycleList);
            $product = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first();
            $beforeRenew = $product->nextduedate;
            $strTime = "+" . $month * $times . " month";
            $afterReNew = date("Y-m-d", strtotime($strTime, strtotime($beforeRenew)));
            $amount = Renew::getPrice($uid, $sid, $billingcycle, false, $promotion, $times);
            $amount["date"] = $afterReNew;
            if( defined("emptyAmount") ) 
            {
                throw new \Exception($RENEWAL_LANG["errorTips"]["CanNotRenewWithThisBillingCycle"], 210);
            }

            Tools::outputJSON($amount);
        }
        catch( \Exception $e ) 
        {
            Tools::outputJSON(array( "status" => "error", "code" => $e->getCode(), "msg" => $e->getMessage() ));
        }
    }

    public static function doRenew($vars)
    {
        try
        {
            $RENEWAL_LANG = Tools::getLang();
            $sid = (int) Tools::safetyInput($_POST["sid"]);
            $uid = (int) Tools::safetyInput($_POST["uid"]);
            Tools::safetyCheck((string) $_POST["sign"], array( $uid, $sid ));
            $systemurl = Tools::getSystemURL();
            $adminName = Tools::getAdminUser();
            $month = (int) Tools::safetyInput($_POST["month"]);
            $times = (int) Tools::safetyInput($_POST["times"]);
            if( $times <= "0" ) 
            {
                $times = "1";
            }

            if( "36" < $times ) 
            {
                $times = "36";
            }

            $promotion = (string) Tools::safetyInput($_POST["promotion"]);
            if( empty($uid) || empty($sid) || empty($month) ) 
            {
                throw new \Exception($RENEWAL_LANG["errorTips"]["WithOutParam"]);
            }

            if( !empty($vars["allowCancleInvoices"]) ) 
            {
                $allowCancleInvoices = true;
            }

            $getProductInvioce = \WHMCS\Database\Capsule::table("tblinvoiceitems")->where("relid", $sid)->where("type", "Hosting")->orderBy("id", "DESC")->first();
            if( !empty($getProductInvioce) ) 
            {
                $invoiceIDs = $getProductInvioce->invoiceid;
                $getInvoicesDetial = \WHMCS\Database\Capsule::table("tblinvoices")->where("id", $invoiceIDs)->get();
                foreach( $getInvoicesDetial as $key => $value ) 
                {
                    if( $value->status == "Unpaid" ) 
                    {
                        if( !$allowCancleInvoices ) 
                        {
                            throw new \Exception($RENEWAL_LANG["errorTips"]["invoiceUnpaid"]);
                        }

                        $cancleInvoices = localAPI("UpdateInvoice", array( "invoiceid" => $value->id, "status" => "Cancelled" ), $adminName);
                        if( !$cancleInvoices["result"] == "success" ) 
                        {
                            throw new \Exception($RENEWAL_LANG["errorTips"]["AutoCancleInvoiceFailed"]);
                        }

                    }

                }
            }

            $billingcycleList = array( 1 => "Monthly", 3 => "Quarterly", 6 => "Semi-Annually", 12 => "Annually", 24 => "Biennially", 36 => "Triennially" );
            $billingcycle = $billingcycleList[$month];
            if( empty($billingcycle) ) 
            {
                $billingcycle = "Monthly";
            }

            $product = \WHMCS\Database\Capsule::table("tblhosting")->where("userid", $uid)->where("id", $sid)->first();
            $products = \WHMCS\Database\Capsule::table("tblproducts")->where("id", $product->packageid)->first();
            $productname = $products->name;
            $groupName = \WHMCS\Database\Capsule::table("tblproductgroups")->where("id", $products->gid)->first()->name;
            $billingcycleBefore = $product->billingcycle;
            $oldPrice = $product->amount;
            $domainstatus = $product->domainstatus;
            if( !empty($promotion) ) 
            {
                $promotions = Promo::checkPromoCode($uid, $sid, $promotion, $product, $billingcycle);
                if( $promotions ) 
                {
                    $multiRenewWithPromo = Tools::getModuleVars("multiRenewWithPromo");
                    if( !empty($multiRenewWithPromo) && 1 < $times ) 
                    {
                        throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["canNotUsePromoWhenMulti"], 209);
                    }

                    $promotionid = $promotions->id;
                    $uses = $promotions->uses;
                    $nowPromoID = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first()->promoid;
                    if( !empty($nowPromoID) ) 
                    {
                        $withoutPromoPrice = Renew::changeBillingCycleToCheckPrice($uid, $sid, $billingcycle);
                        $updateBillingCycle = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycle ));
                        $setNewPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "autorecalc" => true ), $adminName);
                        if( $setNewPrice["result"] != "success" ) 
                        {
                            $updateBillingCycle = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
                            $reductionPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "recurringamount" => $nextCyclePrice ), $adminName);
                            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetNewPrice"], 205);
                        }

                        $getProduct = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first();
                        if( empty($getProduct) ) 
                        {
                            $updateBillingCycle = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
                            $reductionPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "recurringamount" => $nextCyclePrice ), $adminName);
                            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetProductInfo"], 206);
                        }

                        $PromoAmount = $getProduct->amount;
                        $updateBillingCycle = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
                        $reductionPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "recurringamount" => $nextCyclePrice ), $adminName);
                        if( $reductionPrice["result"] != "success" ) 
                        {
                            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotReductPrice"], 208);
                        }

                        $getPromoDetail = \WHMCS\Database\Capsule::table("tblpromotions")->where("id", $nowPromoID)->first();
                        $needCheckPromo = true;
                        if( empty($getPromoDetail) ) 
                        {
                            $needCheckPromo = false;
                        }
                        else
                        {
                            if( $getPromoDetail->recurring == 0 ) 
                            {
                                $needCheckPromo = false;
                            }

                        }

                        if( $needCheckPromo && $withoutPromoPrice != $PromoAmount ) 
                        {
                            define("CYCLEPROMO", true);
                        }

                    }

                }

            }

            if( $billingcycle == $billingcycleBefore ) 
            {
                if( $product->amount == "0.00" || $product->amount == 0 ) 
                {
                    throw new \Exception($RENEWAL_LANG["errorTips"]["CanNotRenewWithThisBillingCycle"]);
                }

            }
            else
            {
                $amount = Renew::changeBillingCycleToCheckPrice($uid, $sid, $billingcycle);
                if( $amount == "0.00" || $amount == 0 ) 
                {
                    throw new \Exception($RENEWAL_LANG["errorTips"]["CanNotRenewWithThisBillingCycle"]);
                }

                define("BILLINGCYCLECHANGE", true);
                $updateBillingCycle = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycle ));
            }

            $invoiceID = Renew::createInvoice($uid, $sid, $product, $times);
            if( $promotions ) 
            {
                $totalAmount = Promo::editInvoiceWhenUsePromoCode($uid, $sid, $promotions, $invoiceID, $times);
                if( $totalAmount == 0 || $totalAmount == "0.00" ) 
                {
                    Renew::extendNextDueDate($product, $invoiceID, $billingcycle, $times);
                }

                $updateProduct = \WHMCS\Database\Capsule::table("tblhosting")->where("id", $sid)->update(array( "promoid" => $promotionid ));
                $uses = $uses + 1;
                $updatePromo = \WHMCS\Database\Capsule::table("tblpromotions")->where("id", $promotionid)->update(array( "uses" => $uses ));
                DB::where("invoiceid", $invoiceID)->where("sid", $sid)->update(array( "promocode" => $promotions->code ));
            }

            $getInvoices = localAPI("GetInvoice", array( "userid" => $uid, "invoiceid" => $invoiceID ), $adminName);
            $new_nextduedate = date("Y-m-d", strtotime("+" . $month * $times . " month", strtotime($product->nextduedate)));
            DB::where("invoiceid", $invoiceID)->where("sid", $sid)->update(array( "new_billingcycle" => $billingcycle, "new_amount" => $getInvoices["subtotal"], "new_nextduedate" => $new_nextduedate ));
            logActivity("renewal: 用户ID：" . $uid . " 产品ID: " . $sid . " 成功创建续费账单 账单ID：" . $invoiceID);
            return array( "pagetitle" => $RENEWAL_LANG["addonsName"], "breadcrumb" => array( "index.php?m=renewal" => $RENEWAL_LANG["addonsName"] ), "templatefile" => "library/templates/confirm", "requirelogin" => true, "vars" => array( "invoiceid" => $invoiceID, "RENEWAL_LANG" => $RENEWAL_LANG ) );
        }
        catch( \Exception $e ) 
        {
            try
            {
                $RENEWAL_LANG = Tools::getLang();
                $sid = (int) Tools::safetyInput($_POST["sid"]);
                if( empty($sid) ) 
                {
                    throw new \Exception($e->getMessage());
                }

                return array( "pagetitle" => $RENEWAL_LANG["addonsName"], "breadcrumb" => array( "index.php?m=renewal" => $RENEWAL_LANG["addonsName"] ), "templatefile" => "library/templates/error", "requirelogin" => true, "vars" => array( "page" => "dorenew", "sid" => $sid, "RENEWAL_LANG" => $RENEWAL_LANG, "info" => $e->getMessage() ) );
            }
            catch( \Exception $e ) 
            {
                return array( "pagetitle" => "续费管理", "breadcrumb" => array( "index.php?m=renewal" => "续费管理" ), "templatefile" => "library/templates/error", "requirelogin" => true, "vars" => array( "page" => "clientarea", "info" => $e->getMessage() ) );
            }
        }
    }

}
?>