<?php 
namespace MxiDev\renewal;


class Promo
{
    public static function checkPromoCode($uid, $sid, $promotion, $product, $billingcycle)
    {
        $adminName = Tools::getAdminUser();
        $RENEWAL_LANG = Tools::getLang();
        if( empty($uid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetUid"], 201);
        }

        if( empty($sid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetSid"], 202);
        }

        $promotions = \Illuminate\Database\Capsule\Manager::table("tblpromotions")->where("code", $promotion)->first();
        $notes = explode("|", $promotions->notes);
        if( !trim($notes[1]) ) 
        {
            $notes[1] = "0";
        }

        if( trim($notes[0]) == "renewal" ) 
        {
            $nowBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first()->billingcycle;
            if( $billingcycle == $nowBillingCycle ) 
            {
                $nowPromoID = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first()->promoid;
                $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => "" ));
                $checkPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first();
                $oldAmount = $checkPrice->amount;
                $setNowPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "autorecalc" => true ), $adminName);
                $getNowPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first();
                $nowAmount = $getNowPrice->amount;
                $reductionPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "recurringamount" => $oldAmount ), $adminName);
                $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => $nowPromoID ));
                if( $oldAmount <= $nowAmount * $notes[1] ) 
                {
                    throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["canNotRenewThisPrice"], 300);
                }

            }

            $promotionid = $promotions->id;
            $cycles = array_filter(explode(",", $promotions->cycles));
            $appliesto = explode(",", $promotions->appliesto);
            $requires = array_filter(explode(",", $promotions->requires));
            $startdate = $promotions->startdate;
            $expirationdate = $promotions->expirationdate;
            $maxuses = $promotions->maxuses;
            $uses = $promotions->uses;
            $onceperclient = $promotions->onceperclient;
            if( time() < strtotime($startdate) ) 
            {
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["PromoaAtivityNotStart"], 300);
            }

            if( strtotime($expirationdate) < time() - 86400 && $expirationdate != "0000-00-00" ) 
            {
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["PromoaAtivityEnd"], 300);
            }

            if( $maxuses != "0" && $maxuses - $uses <= 0 ) 
            {
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["AchieveMaxUse"], 300);
            }

            if( $onceperclient == "1" ) 
            {
                $checkProduct = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("promoid", $promotionid)->where("userid", $uid)->get();
                if( !empty($checkProduct) ) 
                {
                    throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["useOneTime"], 300);
                }

            }

            if( !in_array($product->packageid, $appliesto) ) 
            {
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["thisProductCanNotUse"], 300);
            }

            if( !in_array($billingcycle, $cycles) && !empty($cycles) ) 
            {
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["thisBillingCycleCanNotUse"], 300);
            }

            if( !($promotions->type == "Percentage" || $promotions->type == "Fixed Amount") ) 
            {
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["errorPromoType"], 300);
            }

            $userProduct = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("userid", $uid)->get();
            foreach( $userProduct as $key => $value ) 
            {
                if( in_array($value->packageid, $requires) ) 
                {
                    $haveRequireProduct = true;
                    break;
                }

                $haveRequireProduct = false;
            }
            if( !$haveRequireProduct && !empty($requires) ) 
            {
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["needAnotherProduct"], 300);
            }

            return $promotions;
        }
        else
        {
            define("NOENABLEPROMOCODE", true);
            return false;
        }

    }

    public static function countPromoPrice($uid, $sid, $promotions, $amount, $times)
    {
        $adminName = Tools::getAdminUser();
        $RENEWAL_LANG = Tools::getLang();
        if( empty($uid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetUid"], 201);
        }

        if( empty($sid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetSid"], 202);
        }

        switch( $promotions->type ) 
        {
            case "Percentage":
                $discounts = "100" - $promotions->value;
                $discount = $discounts * 0.01;
                $promotionAmount = $amount * $discount;
                $description = $RENEWAL_LANG["PromoCode"]["tips"]["PromoCode"] . ": " . $promotions->code . " - " . $promotions->value . "% " . $RENEWAL_LANG["PromoCode"]["tips"]["discount"];
                break;
            case "Fixed Amount":
                $fixedAmount = true;
                $promotionAmount = $amount - $promotions->value;
                $description = $RENEWAL_LANG["PromoCode"]["tips"]["PromoCode"] . ": " . $promotions->code . " - " . $promotions->value . " " . $RENEWAL_LANG["PromoCode"]["tips"]["oneTimeDiscount"];
                if( $promotionAmount < 0 ) 
                {
                    $promotionAmount = 0;
                }

                break;
            default:
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["errorPromoType"], 300);
        }
        $promotionAmount = ($fixedAmount ? $amount * $times - $promotions->value : $promotionAmount + $amount * ($times - 1));
        if( $promotionAmount < 0 ) 
        {
            $promotionAmount = 0;
        }

        return array( "status" => "success", "serverid" => $sid, "billingcycle" => $billingcycle, "description" => $description, "oldprice" => number_format($amount * $times, 2), "price" => number_format($promotionAmount, 2) );
    }

    public static function editInvoiceWhenUsePromoCode($uid, $sid, $promotions, $invoiceID, $times)
    {
        $adminName = Tools::getAdminUser();
        $RENEWAL_LANG = Tools::getLang();
        if( empty($uid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetUid"], 201);
        }

        if( empty($sid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetSid"], 202);
        }

        $getInvoices = localAPI("GetInvoice", array( "userid" => $uid, "invoiceid" => $invoiceID ), $adminName);
        if( $getInvoices["result"] != "success" ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotFindInvoiceInfo"]);
        }

        $price = $getInvoices["subtotal"];
        switch( $promotions->type ) 
        {
            case "Percentage":
                $discount = number_format($promotions->value, 2);
                $discounts = "100" - $discount;
                $discountint = $discount * 0.01;
                $afterPromotionAmount = "-" . $price / $times * $discountint;
                $totalAmount = $price / $times * $discounts * 0.01 + $price / $times * ($times - 1);
                $setInvoices = \Illuminate\Database\Capsule\Manager::table("tblinvoiceitems")->insert(array( "invoiceid" => $invoiceID, "userid" => $uid, "type" => "PromoHosting", "relid" => $sid, "description" => $RENEWAL_LANG["PromoCode"]["tips"]["PromoCode"] . ": " . $promotions->code . " - " . $promotions->value . "% " . $RENEWAL_LANG["PromoCode"]["tips"]["discount"], "amount" => $afterPromotionAmount, "duedate" => $getInvoices["duedate"], "paymentmethod" => $getInvoices["paymentmethod"] ));
                break;
            case "Fixed Amount":
                $totalAmount = $price - $promotions->value;
                if( $totalAmount < 0 ) 
                {
                    $totalAmount = 0;
                    $afterPromotionAmount = "-" . $price;
                }
                else
                {
                    $afterPromotionAmount = "-" . $promotions->value;
                }

                $setInvoices = \Illuminate\Database\Capsule\Manager::table("tblinvoiceitems")->insert(array( "invoiceid" => $invoiceID, "userid" => $uid, "type" => "PromoHosting", "relid" => $sid, "description" => $RENEWAL_LANG["PromoCode"]["tips"]["PromoCode"] . ": " . $promotions->code . " - " . $promotions->value . " " . $RENEWAL_LANG["PromoCode"]["tips"]["oneTimeDiscount"], "amount" => $afterPromotionAmount, "duedate" => $getInvoices["duedate"], "paymentmethod" => $getInvoices["paymentmethod"] ));
                break;
            default:
                throw new \Exception($RENEWAL_LANG["PromoCode"]["error"]["errorPromoType"]);
        }
        $updateInvoices = localAPI("UpdateInvoice", array( "invoiceid" => $invoiceID, "total" => $totalAmount, "subtotal" => $totalAmount ), $adminName);
        if( $updateInvoices["result"] != "success" ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotEditInvoice"]);
        }

        return $totalAmount;
    }

}
?>