<?php 
namespace MxiDev\renewal;

if( !class_exists("Renew") ) 
{

class Renew
{
    public static function addTimes($times = "1", $array)
    {
        for( $i = 1; $i < $times; $i++ ) 
        {
            \Illuminate\Database\Capsule\Manager::table("tblinvoiceitems")->insert($array);
        }
    }

    public static function getPrice($uid, $sid, $billingcycle, $getNow = false, $promotion = "", $times = "1")
    {
        $adminName = Tools::getAdminUser();
        $RENEWAL_LANG = Tools::getLang();
        if( empty($uid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetUid"], 201);
        }

        if( empty($sid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetSid"], 202);
        }

        if( empty($billingcycle) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetBillingCycle"], 213);
        }

        if( $times <= "0" ) 
        {
            $times = "1";
        }

        if( "36" < $times ) 
        {
            $times = "36";
        }

        $product = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first();
        if( empty($product) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotFindProduct"], 203);
        }

        $billingcycleBefore = $product->billingcycle;
        if( $billingcycleBefore != $billingcycle ) 
        {
            $amount = self::changeBillingCycleToCheckPrice($uid, $sid, $billingcycle);
        }
        else
        {
            if( $getNow ) 
            {
                $amount = self::changeBillingCycleToCheckPrice($uid, $sid, $billingcycle);
            }
            else
            {
                $amount = $product->amount;
            }

        }

        if( $amount == 0 || $amount == "0.00" ) 
        {
            define("emptyAmount", true);
        }

        if( !empty($promotion) ) 
        {
            $promotions = Promo::checkPromoCode($uid, $sid, $promotion, $product, $billingcycle);
            if( defined("NOENABLEPROMOCODE") ) 
            {
                return array( "status" => "success", "code" => "301", "msg" => $RENEWAL_LANG["PromoCode"]["error"]["canNotFindPromo"], "serverid" => $sid, "billingcycle" => $billingcycle, "price" => number_format($amount * $times, 2) );
            }

            $multiRenewWithPromo = Tools::getModuleVars("multiRenewWithPromo");
            if( !empty($multiRenewWithPromo) && 1 < $times ) 
            {
                return array( "status" => "error", "code" => "301", "msg" => $RENEWAL_LANG["PromoCode"]["error"]["canNotUsePromoWhenMulti"], "serverid" => $sid, "billingcycle" => $billingcycle, "price" => number_format($amount * $times, 2) );
            }

            $nowPromoID = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first()->promoid;
            if( !empty($nowPromoID) ) 
            {
                $getPromoDetail = \Illuminate\Database\Capsule\Manager::table("tblpromotions")->where("id", $nowPromoID)->first();
                $needCheckPromo = true;
                if( empty($getPromoDetail) ) 
                {
                    $needCheckPromo = false;
                }
                else
                {
                    if( $getPromoDetail->recurring == 0 ) 
                    {
                        $needCheckPromo = false;
                    }

                }

                if( $needCheckPromo ) 
                {
                    $amount = self::changeBillingCycleToCheckPrice($uid, $sid, $billingcycle);
                }

            }

            return Promo::countPromoPrice($uid, $sid, $promotions, $amount, $times);
        }

        return array( "status" => "success", "code" => "200", "serverid" => $sid, "billingcycle" => $billingcycle, "price" => number_format($amount * $times, 2) );
    }

    public static function changeBillingCycleToCheckPrice($uid, $sid, $billingcycle)
    {
        $adminName = Tools::getAdminUser();
        $RENEWAL_LANG = Tools::getLang();
        if( empty($uid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetUid"], 201);
        }

        if( empty($sid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetSid"], 202);
        }

        $product = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first();
        if( empty($product) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotFindProduct"], 203);
        }

        $billingcycleBefore = $product->billingcycle;
        $nextCyclePrice = $product->amount;
        $nowPromoID = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first()->promoid;
        $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => "" ));
        $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycle ));
        $setNewPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "autorecalc" => true ), $adminName);
        if( $setNewPrice["result"] != "success" ) 
        {
            $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
            $reductionPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "recurringamount" => $nextCyclePrice ), $adminName);
            $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => $nowPromoID ));
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetNewPrice"], 205);
        }

        $getProduct = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first();
        if( empty($getProduct) ) 
        {
            $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
            $reductionPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "recurringamount" => $nextCyclePrice ), $adminName);
            $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => $nowPromoID ));
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetProductInfo"], 206);
        }

        $amount = $getProduct->amount;
        $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
        $reductionPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "recurringamount" => $nextCyclePrice ), $adminName);
        if( $reductionPrice["result"] != "success" ) 
        {
            $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => $nowPromoID ));
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotReductPrice"], 208);
        }

        $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => $nowPromoID ));
        return $amount;
    }

    public static function createInvoice($uid, $sid, $product, $times)
    {
        $adminName = Tools::getAdminUser();
        $RENEWAL_LANG = Tools::getLang();
        $billingcycleBefore = $product->billingcycle;
        $oldPrice = $product->amount;
        $domainstatus = $product->domainstatus;
        $nowPromoID = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first()->promoid;
        $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => "" ));
        if( defined("BILLINGCYCLECHANGE") || defined("CYCLEPROMO") ) 
        {
            $setNewPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "autorecalc" => true ), $adminName);
        }

        $saveCredit = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->first()->credit;
        $dbid = DB::insertGetId(array( "sid" => $sid, "old_amount" => $oldPrice, "old_billingcycle" => $billingcycleBefore, "old_nextduedate" => $product->nextduedate, "times" => $times, "credit" => $saveCredit, "created_at" => \Carbon\Carbon::now(), "updated_at" => \Carbon\Carbon::now() ));
        if( 0 < $saveCredit || "0.00" < $saveCredit ) 
        {
            $deleteCredit = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->update(array( "credit" => "0.00" ));
        }

        $doGenInvoices = localAPI("GenInvoices", array( "clientid" => $uid, "serviceids" => array( $sid ) ), $adminName);
        if( 0 < $saveCredit || "0.00" < $saveCredit ) 
        {
            $returnCredit = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->update(array( "credit" => $saveCredit ));
        }

        if( !defined("BILLINGCYCLECHANGE") && defined("CYCLEPROMO") ) 
        {
            $reductionPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "amount" => $oldPrice ));
        }

        $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => $nowPromoID ));
        if( $doGenInvoices["result"] != "success" ) 
        {
            $reductionPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "amount" => $oldPrice ));
            $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
            throw new \Exception($RENEWAL_LANG["errorTips"]["errorCreateInvoice"] . ": " . json_encode($doGenInvoices));
        }

        $invoiceID = $doGenInvoices["latestinvoiceid"];
        if( $invoiceID == "0" || empty($invoiceID) ) 
        {
            $tryRenewAfterError = Tools::getModuleVars("tryRenewAfterError");
            if( !empty($tryRenewAfterError) ) 
            {
                $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
                $reductionPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "amount" => $oldPrice ));
                $updatestatus = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "domainstatus" => $domainstatus ));
                unset($invoiceID);
                $nowPromoID = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->first()->promoid;
                $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => "" ));
                if( defined("BILLINGCYCLECHANGE") || defined("CYCLEPROMO") ) 
                {
                    $setNewPrice = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "autorecalc" => true ), $adminName);
                }

                $saveCredit = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->first()->credit;
                DB::where("id", $dbid)->update(array( "sid" => $sid, "old_amount" => $oldPrice, "old_billingcycle" => $billingcycleBefore, "old_nextduedate" => $product->nextduedate, "times" => $times, "credit" => $saveCredit ));
                $productNextDueDate = $product->nextduedate;
                $invoiceItem = \Illuminate\Database\Capsule\Manager::table("tblinvoiceitems")->where("type", "Hosting")->where("userid", $uid)->where("relid", $sid)->where("duedate", ">=", $productNextDueDate)->get();
                foreach( $invoiceItem as $key => $value ) 
                {
                    $invoiceItem[$key] = json_decode(json_encode($value), true);
                }
                $delItem = \Illuminate\Database\Capsule\Manager::table("tblinvoiceitems")->where("type", "Hosting")->where("userid", $uid)->where("relid", $sid)->where("duedate", ">=", $productNextDueDate)->delete();
                $getAddon = \Illuminate\Database\Capsule\Manager::table("tblhostingaddons")->where("userid", $uid)->where("hostingid", $sid)->first();
                $delAddonInvoice = \Illuminate\Database\Capsule\Manager::table("tblinvoiceitems")->where("type", "Addon")->where("userid", $uid)->where("relid", $getAddon->id)->where("duedate", $getAddon->nextduedate)->delete();
                if( 0 < $saveCredit || "0.00" < $saveCredit ) 
                {
                    $deleteCredit = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->update(array( "credit" => "0.00" ));
                }

                $doGenInvoices = localAPI("GenInvoices", array( "clientid" => $uid, "serviceids" => array( $sid ) ), $adminName);
                if( 0 < $saveCredit || "0.00" < $saveCredit ) 
                {
                    $returnCredit = \Illuminate\Database\Capsule\Manager::table("tblclients")->where("id", $uid)->update(array( "credit" => $saveCredit ));
                }

                if( !defined("BILLINGCYCLECHANGE") && defined("CYCLEPROMO") ) 
                {
                    $reductionPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "amount" => $oldPrice ));
                }

                $updatePromoId = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "promoid" => $nowPromoID ));
                $setItem = \Illuminate\Database\Capsule\Manager::table("tblinvoiceitems")->insert($invoiceItem);
                if( $doGenInvoices["result"] != "success" ) 
                {
                    $reductionPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "amount" => $oldPrice ));
                    $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
                    throw new \Exception($RENEWAL_LANG["errorTips"]["errorCreateInvoice"] . ": " . json_encode($doGenInvoices));
                }

                $invoiceID = $doGenInvoices["latestinvoiceid"];
                if( $invoiceID == "0" || empty($invoiceID) ) 
                {
                    $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
                    $reductionPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "amount" => $oldPrice ));
                    $updatestatus = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "domainstatus" => $domainstatus ));
                    throw new \Exception($RENEWAL_LANG["errorTips"]["errorCreateInvoiceAfterTry"]);
                }

            }
            else
            {
                $updateBillingCycle = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "billingcycle" => $billingcycleBefore ));
                $reductionPrice = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "amount" => $oldPrice ));
                $updatestatus = \Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $sid)->where("userid", $uid)->update(array( "domainstatus" => $domainstatus ));
                throw new \Exception($RENEWAL_LANG["errorTips"]["errorCreateInvoiceAfterTry"]);
            }

        }

        $getInvoices = localAPI("GetInvoice", array( "userid" => $uid, "invoiceid" => $invoiceID ), $adminName);
        $updateInvoices = localAPI("UpdateInvoice", array( "invoiceid" => $invoiceID, "credit" => "0.00", "duedate" => date("Y-m-d", strtotime("+1 days")) ), $adminName);
        $updateItem = \Illuminate\Database\Capsule\Manager::table("tblinvoiceitems")->where("invoiceid", $invoiceID)->update(array( "duedate" => date("Y-m-d", strtotime("+1 days")) ));
        if( 1 < $times ) 
        {
            $products = \Illuminate\Database\Capsule\Manager::table("tblproducts")->where("id", $product->packageid)->first();
            $productname = $products->name;
            $groupName = \Illuminate\Database\Capsule\Manager::table("tblproductgroups")->where("id", $products->gid)->first()->name;
            Renew::addTimes($times, array( "invoiceid" => $invoiceID, "userid" => $uid, "type" => "Hosting", "relid" => $sid, "description" => $groupName . "-" . $productname . " - " . $RENEWAL_LANG["MultiRenew"], "amount" => $getInvoices["subtotal"], "duedate" => date("Y-m-d", strtotime("+1 days")), "paymentmethod" => $getInvoices["paymentmethod"] ));
            $beforePrice = $getInvoices["subtotal"] * $times;
            $updateInvoices = localAPI("UpdateInvoice", array( "invoiceid" => $invoiceID, "total" => $beforePrice, "subtotal" => $beforePrice ), $adminName);
        }

        DB::where("id", $dbid)->update(array( "invoiceid" => $invoiceID ));
        return $invoiceID;
    }

    public static function extendNextDueDate($product, $invoiceID, $billingcycle, $times)
    {
        $adminName = Tools::getAdminUser();
        $RENEWAL_LANG = Tools::getLang();
        $sid = $product->id;
        if( empty($sid) ) 
        {
            throw new \Exception($RENEWAL_LANG["errorTips"]["canNotGetSid"]);
        }

        $updateInvoices = localAPI("UpdateInvoice", array( "invoiceid" => $invoiceID, "status" => "Paid" ), $adminName);
        $beforeRenew = $product->nextduedate;
        switch( $billingcycle ) 
        {
            case "Monthly":
                $strTime = "+" . "1" * $times . " month";
                $afterReNew = date("Y-m-d", strtotime($strTime, strtotime($beforeRenew)));
                break;
            case "Quarterly":
                $strTime = "+" . "3" * $times . " month";
                $afterReNew = date("Y-m-d", strtotime($strTime, strtotime($beforeRenew)));
                break;
            case "Semi-Annually":
                $strTime = "+" . "6" * $times . " month";
                $afterReNew = date("Y-m-d", strtotime($strTime, strtotime($beforeRenew)));
                break;
            case "Annually":
                $strTime = "+" . "1" * $times . " year";
                $afterReNew = date("Y-m-d", strtotime($strTime, strtotime($beforeRenew)));
                break;
            case "Biennially":
                $strTime = "+" . "2" * $times . " year";
                $afterReNew = date("Y-m-d", strtotime($strTime, strtotime($beforeRenew)));
                break;
            case "Triennially":
                $strTime = "+" . "3" * $times . " year";
                $afterReNew = date("Y-m-d", strtotime($strTime, strtotime($beforeRenew)));
                break;
            default:
                break;
        }
        $updateProduct = localAPI("UpdateClientProduct", array( "serviceid" => $sid, "nextduedate" => $afterReNew ), $adminName);
        return $afterReNew;
    }

}

}
?>