<?php 
namespace MxiDev\renewal;

if( !class_exists("Tools") ) 
{

class Tools
{
    public static function getRand($len = "11")
    {
        $chars = array( "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" );
        $charsLen = count($chars) - 1;
        shuffle($chars);
        $output = "";
        for( $i = 0; $i < $len; $i++ ) 
        {
            $output .= $chars[mt_rand(0, $charsLen)];
        }
        return $output;
    }

    public static function getLang()
    {
        if( empty($GLOBALS["_LANG"]["locale"]) ) 
        {
            throw new \Exception("无法读取 WHMCS 中语言包的 locale 字段，请检查当前 WHMCS 语言包是否正常");
        }

        $langFile = realpath(__DIR__ . "/../") . "/lang/" . $GLOBALS["_LANG"]["locale"] . ".php";
        if( !is_readable($langFile) ) 
        {
            $langFile = realpath(__DIR__ . "/../") . "/lang/zh_CN.php";
        }

        include($langFile);
        if( empty($RENEWAL_LANG) ) 
        {
            throw new \Exception("无法读取语言包文件 [ " . $langFile . " ] 请检查是否语言包权限、名称存在问题或语言包格式不正确");
        }

        return (array) $RENEWAL_LANG;
    }

    public static function getWHMCSVersion()
    {
        if( empty($GLOBALS["CONFIG"]["Version"]) ) 
        {
            $version = \Illuminate\Database\Capsule\Manager::table("tblconfiguration")->where("setting", "Version")->first()->value;
        }
        else
        {
            $version = $GLOBALS["CONFIG"]["Version"];
        }

        if( empty($version) ) 
        {
            throw new \Exception("无法获取WHMCS版本信息");
        }

        $version = explode(".", $version);
        return $version;
    }

    public static function getSystemURL()
    {
        if( empty($GLOBALS["CONFIG"]) ) 
        {
            $result = \Illuminate\Database\Capsule\Manager::table("tblconfiguration")->where("setting", "SystemSSLURL")->first()->value;
            if( empty($result) ) 
            {
                $result = \Illuminate\Database\Capsule\Manager::table("tblconfiguration")->where("setting", "SystemURL")->first()->value;
            }

            if( empty($result) ) 
            {
                throw new \Exception("无法从数据库中获取 WHMCS 的地址");
            }

        }
        else
        {
            if( !empty($GLOBALS["CONFIG"]["SystemSSLURL"]) ) 
            {
                $result = $GLOBALS["CONFIG"]["SystemSSLURL"] . "/";
            }
            else
            {
                if( ($result = $GLOBALS["CONFIG"]["SystemURL"]) ) 
                {
                    $result = $GLOBALS["CONFIG"]["SystemURL"] . "/";
                }
                else
                {
                    throw new \Exception("无法从全局变量中获取 WHMCS 地址");
                }

            }

        }

        return $result;
    }

    public static function getAdminUser()
    {
        $getInfo = \Illuminate\Database\Capsule\Manager::table("tbladmins")->orderBy("id", "ASC")->first();
        $adminUser = (string) $getInfo->username;
        if( empty($adminUser) ) 
        {
            throw new \Exception("无法获取 WHMCS 管理员名称信息");
        }

        return $adminUser;
    }

    public static function getModuleVars($var = "")
    {
        $var = (string) trim($var);
        if( empty($var) ) 
        {
            throw new \Exception("未传入需要获取的模块变量");
        }

        $value = \Illuminate\Database\Capsule\Manager::table("tbladdonmodules")->where("module", Apps::$modulename)->where("setting", $var)->first()->value;
        return $value;
    }

    public static function safetyInput($data)
    {
        return htmlspecialchars(stripslashes(trim($data)));
    }

    public static function safetyCheck($getSign = "", $vars = array(  ), $get = false)
    {
        $getSign = (string) trim($getSign);
        foreach( $vars as $key => $value ) 
        {
            $param .= $value;
        }
        $localSign = self::getModuleVars("sign");
        $param .= date("Y-m-d");
        $param .= $localSign;
        if( $get ) 
        {
            return (string) md5($param);
        }

        if( md5($param) != $getSign ) 
        {
            throw new \Exception("安全认证失败，请刷新网页后重试", 101);
        }

        return true;
    }

    public static function outputJSON($data)
    {
        if( empty($data) ) 
        {
            throw new \Exception("未定义需要JSON输出的内容");
        }

        header("Content-type: application/json");
        exit( json_encode($data, JSON_UNESCAPED_UNICODE) );
    }

    public static function getSmarty(array $page)
    {
        $templates_c = (string) $GLOBALS["templates_compiledir"];
        if( !is_readable($templates_c) || !is_writeable($templates_c) ) 
        {
            throw new \Exception("模板缓存目录 [ " . $templates_c . " ] 无法读取或写入，请检查目录权限");
        }

        if( isset($page["file"]) ) 
        {
            $smarty = new \Smarty();
            if( isset($page["vars"]) ) 
            {
                if( is_array($page["vars"]) ) 
                {
                    $smarty->assign($page["vars"]);
                }
                else
                {
                    throw new \Exception("已定义的传值字段并非数组");
                }

            }

            if( !isset($page["dir"]) ) 
            {
                throw new \Exception("未定义模板位置");
            }

            $dir = $page["dir"];
            $smarty->assign(array( "systemurl" => self::getSystemURL() ));
            if( isset($page["cache"]) && $page["cache"] == true ) 
            {
                $smarty->caching = true;
            }
            else
            {
                $smarty->caching = false;
            }

            $smarty->compile_dir = $GLOBALS["templates_compiledir"];
            return (string) $smarty->fetch($dir . $page["file"] . ".tpl");
        }

        throw new \Exception("未定义模板文件");
    }

    public static function putFile($path, $content)
    {
        if( empty($path) ) 
        {
            throw new \Exception("未设置文件目录");
        }

        if( empty($content) ) 
        {
            throw new \Exception("未设置需要写入的内容");
        }

        $write = file_put_contents($path, htmlspecialchars_decode($content));
        if( !$write ) 
        {
            throw new \Exception("无法读取或写入，请检查" . $path . "目录权限");
        }

    }

    public static function getFile($file = "")
    {
        if( file_exists($file) ) 
        {
            $content = file_get_contents($file);
            return $content;
        }

    }

    public static function delFile($file = "")
    {
        if( file_exists($file) ) 
        {
            $del = unlink($file);
            if( !$del ) 
            {
                throw new \Exception("文件 " . $file . "删除失败，请检查目录权限");
            }

        }

    }

    public static function getTemplatesC()
    {
        $templates_c = (string) $GLOBALS["templates_compiledir"];
        if( !is_readable($templates_c) || !is_writeable($templates_c) ) 
        {
            throw new \Exception("模板缓存目录 [ " . $templates_c . " ] 无法读取或写入，请检查目录权限");
        }

        return $templates_c;
    }

    public static function trimArray($array)
    {
        if( !is_array($array) ) 
        {
            return trim($array);
        }

        return array_map("trimArray", $array);
    }

    public static function getRoute($value)
    {
        if( empty($value) ) 
        {
            $rand = rand(0, 10);
            sleep($rand);
        }

        return $value;
    }

    public static function getServerInfo()
    {
        $domain = $_SERVER["SERVER_NAME"];
        if( !filter_var($domain, FILTER_VALIDATE_URL) ) 
        {
            $domain = $_SERVER["HTTP_HOST"];
        }

        if( empty($domain) ) 
        {
            $domain = (string) Tools::getSystemURL();
            $domain = parse_url($domain);
            $domain = $domain["host"];
        }

        $usersip = (isset($_SERVER["SERVER_ADDR"]) ? $_SERVER["SERVER_ADDR"] : $_SERVER["LOCAL_ADDR"]);
        $dirpath = dirname(dirname(dirname(__FILE__)));
        $licensekey = self::getModuleVars("licensekey");
        $info = array( "licensekey" => $licensekey, "domain" => $domain, "ip" => $usersip, "dir" => $dirpath );
        return $info;
    }

}

}
?>